/** @file function.cpp
 *
 *  Implementation of class function. */

/*
 *  This file was generated automatically by function.pl.
 *  Please do not modify it directly, edit the perl script instead!
 *  function.pl options: $maxargs=10
 *
 *  GiNaC Copyright (C) 1999-2000 Johannes Gutenberg University Mainz, Germany
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <string>
#include <stdexcept>
#include <list>

#include "function.h"
#include "ex.h"
#include "archive.h"
#include "inifcns.h"
#include "utils.h"
#include "debugmsg.h"
#include "remember.h"

#ifndef NO_NAMESPACE_GINAC
namespace GiNaC {
#endif // ndef NO_NAMESPACE_GINAC

//////////
// helper class function_options
//////////

function_options::function_options()
{
    initialize();
}

function_options::function_options(string const & n, string const & tn)
{
    initialize();
    set_name(n,tn);
}

function_options::~function_options()
{
    // nothing to clean up at the moment
}

void function_options::initialize(void)
{
    set_name("unnamed_function","\\operatorname{unnamed}");
    nparams=0;
    eval_f=evalf_f=derivative_f=series_f=0;
    evalf_params_first=true;
    use_return_type=false;
    use_remember=false;
    functions_with_same_name=1;
}

function_options & function_options::set_name(string const & n,
                                              string const & tn)
{
    name=n;
    if (tn==string()) {
        TeX_name="\\operatorname{"+name+"}";
    } else {
        TeX_name=tn;
    }
    return *this;
}

// the following lines have been generated for max. 10 parameters
function_options & function_options::eval_func(eval_funcp_1 e)
{
    test_and_set_nparams(1);
    eval_f=eval_funcp(e);
    return *this;
}        
function_options & function_options::eval_func(eval_funcp_2 e)
{
    test_and_set_nparams(2);
    eval_f=eval_funcp(e);
    return *this;
}        
function_options & function_options::eval_func(eval_funcp_3 e)
{
    test_and_set_nparams(3);
    eval_f=eval_funcp(e);
    return *this;
}        
function_options & function_options::eval_func(eval_funcp_4 e)
{
    test_and_set_nparams(4);
    eval_f=eval_funcp(e);
    return *this;
}        
function_options & function_options::eval_func(eval_funcp_5 e)
{
    test_and_set_nparams(5);
    eval_f=eval_funcp(e);
    return *this;
}        
function_options & function_options::eval_func(eval_funcp_6 e)
{
    test_and_set_nparams(6);
    eval_f=eval_funcp(e);
    return *this;
}        
function_options & function_options::eval_func(eval_funcp_7 e)
{
    test_and_set_nparams(7);
    eval_f=eval_funcp(e);
    return *this;
}        
function_options & function_options::eval_func(eval_funcp_8 e)
{
    test_and_set_nparams(8);
    eval_f=eval_funcp(e);
    return *this;
}        
function_options & function_options::eval_func(eval_funcp_9 e)
{
    test_and_set_nparams(9);
    eval_f=eval_funcp(e);
    return *this;
}        
function_options & function_options::eval_func(eval_funcp_10 e)
{
    test_and_set_nparams(10);
    eval_f=eval_funcp(e);
    return *this;
}        

function_options & function_options::evalf_func(evalf_funcp_1 ef)
{
    test_and_set_nparams(1);
    evalf_f=evalf_funcp(ef);
    return *this;
}        
function_options & function_options::evalf_func(evalf_funcp_2 ef)
{
    test_and_set_nparams(2);
    evalf_f=evalf_funcp(ef);
    return *this;
}        
function_options & function_options::evalf_func(evalf_funcp_3 ef)
{
    test_and_set_nparams(3);
    evalf_f=evalf_funcp(ef);
    return *this;
}        
function_options & function_options::evalf_func(evalf_funcp_4 ef)
{
    test_and_set_nparams(4);
    evalf_f=evalf_funcp(ef);
    return *this;
}        
function_options & function_options::evalf_func(evalf_funcp_5 ef)
{
    test_and_set_nparams(5);
    evalf_f=evalf_funcp(ef);
    return *this;
}        
function_options & function_options::evalf_func(evalf_funcp_6 ef)
{
    test_and_set_nparams(6);
    evalf_f=evalf_funcp(ef);
    return *this;
}        
function_options & function_options::evalf_func(evalf_funcp_7 ef)
{
    test_and_set_nparams(7);
    evalf_f=evalf_funcp(ef);
    return *this;
}        
function_options & function_options::evalf_func(evalf_funcp_8 ef)
{
    test_and_set_nparams(8);
    evalf_f=evalf_funcp(ef);
    return *this;
}        
function_options & function_options::evalf_func(evalf_funcp_9 ef)
{
    test_and_set_nparams(9);
    evalf_f=evalf_funcp(ef);
    return *this;
}        
function_options & function_options::evalf_func(evalf_funcp_10 ef)
{
    test_and_set_nparams(10);
    evalf_f=evalf_funcp(ef);
    return *this;
}        

function_options & function_options::derivative_func(derivative_funcp_1 d)
{
    test_and_set_nparams(1);
    derivative_f=derivative_funcp(d);
    return *this;
}        
function_options & function_options::derivative_func(derivative_funcp_2 d)
{
    test_and_set_nparams(2);
    derivative_f=derivative_funcp(d);
    return *this;
}        
function_options & function_options::derivative_func(derivative_funcp_3 d)
{
    test_and_set_nparams(3);
    derivative_f=derivative_funcp(d);
    return *this;
}        
function_options & function_options::derivative_func(derivative_funcp_4 d)
{
    test_and_set_nparams(4);
    derivative_f=derivative_funcp(d);
    return *this;
}        
function_options & function_options::derivative_func(derivative_funcp_5 d)
{
    test_and_set_nparams(5);
    derivative_f=derivative_funcp(d);
    return *this;
}        
function_options & function_options::derivative_func(derivative_funcp_6 d)
{
    test_and_set_nparams(6);
    derivative_f=derivative_funcp(d);
    return *this;
}        
function_options & function_options::derivative_func(derivative_funcp_7 d)
{
    test_and_set_nparams(7);
    derivative_f=derivative_funcp(d);
    return *this;
}        
function_options & function_options::derivative_func(derivative_funcp_8 d)
{
    test_and_set_nparams(8);
    derivative_f=derivative_funcp(d);
    return *this;
}        
function_options & function_options::derivative_func(derivative_funcp_9 d)
{
    test_and_set_nparams(9);
    derivative_f=derivative_funcp(d);
    return *this;
}        
function_options & function_options::derivative_func(derivative_funcp_10 d)
{
    test_and_set_nparams(10);
    derivative_f=derivative_funcp(d);
    return *this;
}        

function_options & function_options::series_func(series_funcp_1 s)
{
    test_and_set_nparams(1);
    series_f=series_funcp(s);
    return *this;
}        
function_options & function_options::series_func(series_funcp_2 s)
{
    test_and_set_nparams(2);
    series_f=series_funcp(s);
    return *this;
}        
function_options & function_options::series_func(series_funcp_3 s)
{
    test_and_set_nparams(3);
    series_f=series_funcp(s);
    return *this;
}        
function_options & function_options::series_func(series_funcp_4 s)
{
    test_and_set_nparams(4);
    series_f=series_funcp(s);
    return *this;
}        
function_options & function_options::series_func(series_funcp_5 s)
{
    test_and_set_nparams(5);
    series_f=series_funcp(s);
    return *this;
}        
function_options & function_options::series_func(series_funcp_6 s)
{
    test_and_set_nparams(6);
    series_f=series_funcp(s);
    return *this;
}        
function_options & function_options::series_func(series_funcp_7 s)
{
    test_and_set_nparams(7);
    series_f=series_funcp(s);
    return *this;
}        
function_options & function_options::series_func(series_funcp_8 s)
{
    test_and_set_nparams(8);
    series_f=series_funcp(s);
    return *this;
}        
function_options & function_options::series_func(series_funcp_9 s)
{
    test_and_set_nparams(9);
    series_f=series_funcp(s);
    return *this;
}        
function_options & function_options::series_func(series_funcp_10 s)
{
    test_and_set_nparams(10);
    series_f=series_funcp(s);
    return *this;
}        

// end of generated lines

function_options & function_options::set_return_type(unsigned rt, unsigned rtt)
{
    use_return_type=true;
    return_type=rt;
    return_type_tinfo=rtt;
    return *this;
}

function_options & function_options::do_not_evalf_params(void)
{
    evalf_params_first=false;
    return *this;
}

function_options & function_options::remember(unsigned size,
                                              unsigned assoc_size,
                                              unsigned strategy)
{
    use_remember=true;
    remember_size=size;
    remember_assoc_size=assoc_size;
    remember_strategy=strategy;
    return *this;
}

function_options & function_options::overloaded(unsigned o)
{
    functions_with_same_name=o;
    return *this;
}
    
void function_options::test_and_set_nparams(unsigned n)
{
    if (nparams==0) {
        nparams=n;
    } else if (nparams!=n) {
        // we do not throw an exception here because this code is
        // usually executed before main(), so the exception could not
        // caught anyhow
        cerr << "WARNING: number of parameters ("
             << n << ") differs from number set before (" 
             << nparams << ")" << endl;
    }
}

GINAC_IMPLEMENT_REGISTERED_CLASS(function, exprseq)

//////////
// default constructor, destructor, copy constructor assignment operator and helpers
//////////

// public

function::function() : serial(0)
{
    debugmsg("function default constructor",LOGLEVEL_CONSTRUCT);
    tinfo_key = TINFO_function;
}

function::~function()
{
    debugmsg("function destructor",LOGLEVEL_DESTRUCT);
    destroy(0);
}

function::function(const function & other)
{
    debugmsg("function copy constructor",LOGLEVEL_CONSTRUCT);
    copy(other);
}

const function & function::operator=(const function & other)
{
    debugmsg("function operator=",LOGLEVEL_ASSIGNMENT);
    if (this != &other) {
        destroy(1);
        copy(other);
    }
    return *this;
}

// protected

void function::copy(const function & other)
{
    exprseq::copy(other);
    serial=other.serial;
}

void function::destroy(bool call_parent)
{
    if (call_parent) exprseq::destroy(call_parent);
}

//////////
// other constructors
//////////

// public

function::function(unsigned ser) : serial(ser)
{
    debugmsg("function constructor from unsigned",LOGLEVEL_CONSTRUCT);
    tinfo_key = TINFO_function;
}

// the following lines have been generated for max. 10 parameters
function::function(unsigned ser, const ex & param1)
    : exprseq(param1), serial(ser)
{
    debugmsg("function constructor from unsigned,1*ex",LOGLEVEL_CONSTRUCT);
    tinfo_key = TINFO_function;
}
function::function(unsigned ser, const ex & param1, const ex & param2)
    : exprseq(param1, param2), serial(ser)
{
    debugmsg("function constructor from unsigned,2*ex",LOGLEVEL_CONSTRUCT);
    tinfo_key = TINFO_function;
}
function::function(unsigned ser, const ex & param1, const ex & param2, const ex & param3)
    : exprseq(param1, param2, param3), serial(ser)
{
    debugmsg("function constructor from unsigned,3*ex",LOGLEVEL_CONSTRUCT);
    tinfo_key = TINFO_function;
}
function::function(unsigned ser, const ex & param1, const ex & param2, const ex & param3, const ex & param4)
    : exprseq(param1, param2, param3, param4), serial(ser)
{
    debugmsg("function constructor from unsigned,4*ex",LOGLEVEL_CONSTRUCT);
    tinfo_key = TINFO_function;
}
function::function(unsigned ser, const ex & param1, const ex & param2, const ex & param3, const ex & param4, const ex & param5)
    : exprseq(param1, param2, param3, param4, param5), serial(ser)
{
    debugmsg("function constructor from unsigned,5*ex",LOGLEVEL_CONSTRUCT);
    tinfo_key = TINFO_function;
}
function::function(unsigned ser, const ex & param1, const ex & param2, const ex & param3, const ex & param4, const ex & param5, const ex & param6)
    : exprseq(param1, param2, param3, param4, param5, param6), serial(ser)
{
    debugmsg("function constructor from unsigned,6*ex",LOGLEVEL_CONSTRUCT);
    tinfo_key = TINFO_function;
}
function::function(unsigned ser, const ex & param1, const ex & param2, const ex & param3, const ex & param4, const ex & param5, const ex & param6, const ex & param7)
    : exprseq(param1, param2, param3, param4, param5, param6, param7), serial(ser)
{
    debugmsg("function constructor from unsigned,7*ex",LOGLEVEL_CONSTRUCT);
    tinfo_key = TINFO_function;
}
function::function(unsigned ser, const ex & param1, const ex & param2, const ex & param3, const ex & param4, const ex & param5, const ex & param6, const ex & param7, const ex & param8)
    : exprseq(param1, param2, param3, param4, param5, param6, param7, param8), serial(ser)
{
    debugmsg("function constructor from unsigned,8*ex",LOGLEVEL_CONSTRUCT);
    tinfo_key = TINFO_function;
}
function::function(unsigned ser, const ex & param1, const ex & param2, const ex & param3, const ex & param4, const ex & param5, const ex & param6, const ex & param7, const ex & param8, const ex & param9)
    : exprseq(param1, param2, param3, param4, param5, param6, param7, param8, param9), serial(ser)
{
    debugmsg("function constructor from unsigned,9*ex",LOGLEVEL_CONSTRUCT);
    tinfo_key = TINFO_function;
}
function::function(unsigned ser, const ex & param1, const ex & param2, const ex & param3, const ex & param4, const ex & param5, const ex & param6, const ex & param7, const ex & param8, const ex & param9, const ex & param10)
    : exprseq(param1, param2, param3, param4, param5, param6, param7, param8, param9, param10), serial(ser)
{
    debugmsg("function constructor from unsigned,10*ex",LOGLEVEL_CONSTRUCT);
    tinfo_key = TINFO_function;
}

// end of generated lines

function::function(unsigned ser, const exprseq & es) : exprseq(es), serial(ser)
{
    debugmsg("function constructor from unsigned,exprseq",LOGLEVEL_CONSTRUCT);
    tinfo_key = TINFO_function;
}

function::function(unsigned ser, const exvector & v, bool discardable) 
    : exprseq(v,discardable), serial(ser)
{
    debugmsg("function constructor from string,exvector,bool",LOGLEVEL_CONSTRUCT);
    tinfo_key = TINFO_function;
}

function::function(unsigned ser, exvector * vp) 
    : exprseq(vp), serial(ser)
{
    debugmsg("function constructor from unsigned,exvector *",LOGLEVEL_CONSTRUCT);
    tinfo_key = TINFO_function;
}

//////////
// archiving
//////////

/** Construct object from archive_node. */
function::function(const archive_node &n, const lst &sym_lst) : inherited(n, sym_lst)
{
    debugmsg("function constructor from archive_node", LOGLEVEL_CONSTRUCT);

    // Find serial number by function name
    string s;
    if (n.find_string("name", s)) {
        unsigned int ser = 0;
        vector<function_options>::const_iterator i = registered_functions().begin(), iend = registered_functions().end();
        while (i != iend) {
            if (s == i->name) {
                serial = ser;
                return;
            }
            i++; ser++;
        }
        throw (std::runtime_error("unknown function '" + s + "' in archive"));
    } else
        throw (std::runtime_error("unnamed function in archive"));
}

/** Unarchive the object. */
ex function::unarchive(const archive_node &n, const lst &sym_lst)
{
    return (new function(n, sym_lst))->setflag(status_flags::dynallocated);
}

/** Archive the object. */
void function::archive(archive_node &n) const
{
    inherited::archive(n);
    GINAC_ASSERT(serial < registered_functions().size());
    n.add_string("name", registered_functions()[serial].name);
}

//////////
// functions overriding virtual functions from bases classes
//////////

// public

basic * function::duplicate() const
{
    debugmsg("function duplicate",LOGLEVEL_DUPLICATE);
    return new function(*this);
}

void function::printraw(ostream & os) const
{
    debugmsg("function printraw",LOGLEVEL_PRINT);

    GINAC_ASSERT(serial<registered_functions().size());

    os << "function(name=" << registered_functions()[serial].name;
    for (exvector::const_iterator it=seq.begin(); it!=seq.end(); ++it) {
        os << ",";
        (*it).bp->print(os);
    }
    os << ")";
}

void function::print(ostream & os, unsigned upper_precedence) const
{
    debugmsg("function print",LOGLEVEL_PRINT);

    GINAC_ASSERT(serial<registered_functions().size());

    os << registered_functions()[serial].name;
    printseq(os,'(',',',')',exprseq::precedence,function::precedence);
}

void function::printtree(ostream & os, unsigned indent) const
{
    debugmsg("function printtree",LOGLEVEL_PRINT);

    GINAC_ASSERT(serial<registered_functions().size());

    os << string(indent,' ') << "function "
       << registered_functions()[serial].name
       << ", hash=" << hashvalue << " (0x" << hex << hashvalue << dec << ")"
       << ", flags=" << flags
       << ", nops=" << nops() << endl;
    for (unsigned i=0; i<nops(); ++i) {
        seq[i].printtree(os,indent+delta_indent);
    }
    os << string(indent+delta_indent,' ') << "=====" << endl;
}

void function::printcsrc(ostream & os, unsigned type, unsigned upper_precedence) const
{
    debugmsg("function print csrc",LOGLEVEL_PRINT);

    GINAC_ASSERT(serial<registered_functions().size());

	// Print function name in lowercase
    string lname;
    lname=registered_functions()[serial].name;
    for (unsigned i=0; i<lname.size(); i++)
        lname[i] = tolower(lname[i]);
    os << lname << "(";

	// Print arguments, separated by commas
    exvector::const_iterator it = seq.begin();
    exvector::const_iterator itend = seq.end();
    while (it != itend) {
        it->bp->printcsrc(os, type, 0);
        it++;
        if (it != itend)
            os << ",";
    }
    os << ")";
}

ex function::expand(unsigned options) const
{
    return this->setflag(status_flags::expanded);
}

ex function::eval(int level) const
{
    GINAC_ASSERT(serial<registered_functions().size());

    if (level>1) {
        // first evaluate children, then we will end up here again
        return function(serial,evalchildren(level));
    }

    if (registered_functions()[serial].eval_f==0) {
        return this->hold();
    }

    bool use_remember=registered_functions()[serial].use_remember;
    ex eval_result;
    if (use_remember && lookup_remember_table(eval_result)) {
        return eval_result;
    }

    switch (registered_functions()[serial].nparams) {
        // the following lines have been generated for max. 10 parameters
    case 1:
        eval_result=((eval_funcp_1)(registered_functions()[serial].eval_f))(seq[1-1]);
        break;
    case 2:
        eval_result=((eval_funcp_2)(registered_functions()[serial].eval_f))(seq[1-1], seq[2-1]);
        break;
    case 3:
        eval_result=((eval_funcp_3)(registered_functions()[serial].eval_f))(seq[1-1], seq[2-1], seq[3-1]);
        break;
    case 4:
        eval_result=((eval_funcp_4)(registered_functions()[serial].eval_f))(seq[1-1], seq[2-1], seq[3-1], seq[4-1]);
        break;
    case 5:
        eval_result=((eval_funcp_5)(registered_functions()[serial].eval_f))(seq[1-1], seq[2-1], seq[3-1], seq[4-1], seq[5-1]);
        break;
    case 6:
        eval_result=((eval_funcp_6)(registered_functions()[serial].eval_f))(seq[1-1], seq[2-1], seq[3-1], seq[4-1], seq[5-1], seq[6-1]);
        break;
    case 7:
        eval_result=((eval_funcp_7)(registered_functions()[serial].eval_f))(seq[1-1], seq[2-1], seq[3-1], seq[4-1], seq[5-1], seq[6-1], seq[7-1]);
        break;
    case 8:
        eval_result=((eval_funcp_8)(registered_functions()[serial].eval_f))(seq[1-1], seq[2-1], seq[3-1], seq[4-1], seq[5-1], seq[6-1], seq[7-1], seq[8-1]);
        break;
    case 9:
        eval_result=((eval_funcp_9)(registered_functions()[serial].eval_f))(seq[1-1], seq[2-1], seq[3-1], seq[4-1], seq[5-1], seq[6-1], seq[7-1], seq[8-1], seq[9-1]);
        break;
    case 10:
        eval_result=((eval_funcp_10)(registered_functions()[serial].eval_f))(seq[1-1], seq[2-1], seq[3-1], seq[4-1], seq[5-1], seq[6-1], seq[7-1], seq[8-1], seq[9-1], seq[10-1]);
        break;

        // end of generated lines
    default:
        throw(std::logic_error("function::eval(): invalid nparams"));
    }
    if (use_remember) {
        store_remember_table(eval_result);
    }
    return eval_result;
}

ex function::evalf(int level) const
{
    GINAC_ASSERT(serial<registered_functions().size());

    exvector eseq=evalfchildren(level);
    
    if (registered_functions()[serial].evalf_f==0) {
        return function(serial,eseq).hold();
    }
    switch (registered_functions()[serial].nparams) {
        // the following lines have been generated for max. 10 parameters
    case 1:
        return ((evalf_funcp_1)(registered_functions()[serial].evalf_f))(eseq[1-1]);
        break;
    case 2:
        return ((evalf_funcp_2)(registered_functions()[serial].evalf_f))(eseq[1-1], eseq[2-1]);
        break;
    case 3:
        return ((evalf_funcp_3)(registered_functions()[serial].evalf_f))(eseq[1-1], eseq[2-1], eseq[3-1]);
        break;
    case 4:
        return ((evalf_funcp_4)(registered_functions()[serial].evalf_f))(eseq[1-1], eseq[2-1], eseq[3-1], eseq[4-1]);
        break;
    case 5:
        return ((evalf_funcp_5)(registered_functions()[serial].evalf_f))(eseq[1-1], eseq[2-1], eseq[3-1], eseq[4-1], eseq[5-1]);
        break;
    case 6:
        return ((evalf_funcp_6)(registered_functions()[serial].evalf_f))(eseq[1-1], eseq[2-1], eseq[3-1], eseq[4-1], eseq[5-1], eseq[6-1]);
        break;
    case 7:
        return ((evalf_funcp_7)(registered_functions()[serial].evalf_f))(eseq[1-1], eseq[2-1], eseq[3-1], eseq[4-1], eseq[5-1], eseq[6-1], eseq[7-1]);
        break;
    case 8:
        return ((evalf_funcp_8)(registered_functions()[serial].evalf_f))(eseq[1-1], eseq[2-1], eseq[3-1], eseq[4-1], eseq[5-1], eseq[6-1], eseq[7-1], eseq[8-1]);
        break;
    case 9:
        return ((evalf_funcp_9)(registered_functions()[serial].evalf_f))(eseq[1-1], eseq[2-1], eseq[3-1], eseq[4-1], eseq[5-1], eseq[6-1], eseq[7-1], eseq[8-1], eseq[9-1]);
        break;
    case 10:
        return ((evalf_funcp_10)(registered_functions()[serial].evalf_f))(eseq[1-1], eseq[2-1], eseq[3-1], eseq[4-1], eseq[5-1], eseq[6-1], eseq[7-1], eseq[8-1], eseq[9-1], eseq[10-1]);
        break;

        // end of generated lines
    }
    throw(std::logic_error("function::evalf(): invalid nparams"));
}

ex function::thisexprseq(const exvector & v) const
{
    return function(serial,v);
}

ex function::thisexprseq(exvector * vp) const
{
    return function(serial,vp);
}

/** Implementation of ex::series for functions.
 *  @see ex::series */
ex function::series(const symbol & s, const ex & point, int order) const
{
    GINAC_ASSERT(serial<registered_functions().size());

    if (registered_functions()[serial].series_f==0) {
        return basic::series(s, point, order);
    }
    ex res;
    switch (registered_functions()[serial].nparams) {
        // the following lines have been generated for max. 10 parameters
    case 1:
        try {
            res = ((series_funcp_1)(registered_functions()[serial].series_f))(seq[1-1],s,point,order);
        } catch (do_taylor) {
            res = basic::series(s, point, order);
        }
        return res;
        break;
    case 2:
        try {
            res = ((series_funcp_2)(registered_functions()[serial].series_f))(seq[1-1], seq[2-1],s,point,order);
        } catch (do_taylor) {
            res = basic::series(s, point, order);
        }
        return res;
        break;
    case 3:
        try {
            res = ((series_funcp_3)(registered_functions()[serial].series_f))(seq[1-1], seq[2-1], seq[3-1],s,point,order);
        } catch (do_taylor) {
            res = basic::series(s, point, order);
        }
        return res;
        break;
    case 4:
        try {
            res = ((series_funcp_4)(registered_functions()[serial].series_f))(seq[1-1], seq[2-1], seq[3-1], seq[4-1],s,point,order);
        } catch (do_taylor) {
            res = basic::series(s, point, order);
        }
        return res;
        break;
    case 5:
        try {
            res = ((series_funcp_5)(registered_functions()[serial].series_f))(seq[1-1], seq[2-1], seq[3-1], seq[4-1], seq[5-1],s,point,order);
        } catch (do_taylor) {
            res = basic::series(s, point, order);
        }
        return res;
        break;
    case 6:
        try {
            res = ((series_funcp_6)(registered_functions()[serial].series_f))(seq[1-1], seq[2-1], seq[3-1], seq[4-1], seq[5-1], seq[6-1],s,point,order);
        } catch (do_taylor) {
            res = basic::series(s, point, order);
        }
        return res;
        break;
    case 7:
        try {
            res = ((series_funcp_7)(registered_functions()[serial].series_f))(seq[1-1], seq[2-1], seq[3-1], seq[4-1], seq[5-1], seq[6-1], seq[7-1],s,point,order);
        } catch (do_taylor) {
            res = basic::series(s, point, order);
        }
        return res;
        break;
    case 8:
        try {
            res = ((series_funcp_8)(registered_functions()[serial].series_f))(seq[1-1], seq[2-1], seq[3-1], seq[4-1], seq[5-1], seq[6-1], seq[7-1], seq[8-1],s,point,order);
        } catch (do_taylor) {
            res = basic::series(s, point, order);
        }
        return res;
        break;
    case 9:
        try {
            res = ((series_funcp_9)(registered_functions()[serial].series_f))(seq[1-1], seq[2-1], seq[3-1], seq[4-1], seq[5-1], seq[6-1], seq[7-1], seq[8-1], seq[9-1],s,point,order);
        } catch (do_taylor) {
            res = basic::series(s, point, order);
        }
        return res;
        break;
    case 10:
        try {
            res = ((series_funcp_10)(registered_functions()[serial].series_f))(seq[1-1], seq[2-1], seq[3-1], seq[4-1], seq[5-1], seq[6-1], seq[7-1], seq[8-1], seq[9-1], seq[10-1],s,point,order);
        } catch (do_taylor) {
            res = basic::series(s, point, order);
        }
        return res;
        break;

        // end of generated lines
    }
    throw(std::logic_error("function::series(): invalid nparams"));
}

// protected


/** Implementation of ex::diff() for functions. It applies the chain rule,
 *  except for the Order term function.
 *  @see ex::diff */
ex function::derivative(const symbol & s) const
{
    ex result;
    
    if (serial==function_index_Order) {
        // Order Term function only differentiates the argument
        return Order(seq[0].diff(s));
    } else {
        // Chain rule
        ex arg_diff;
        for (unsigned i=0; i!=seq.size(); i++) {
            arg_diff = seq[i].diff(s);
            // We apply the chain rule only when it makes sense.  This is not
            // just for performance reasons but also to allow functions to
            // throw when differentiated with respect to one of its arguments
            // without running into trouble with our automatic full
            // differentiation:
            if (!arg_diff.is_zero())
                result += pderivative(i)*arg_diff;
        }
    }
    return result;
}

int function::compare_same_type(const basic & other) const
{
    GINAC_ASSERT(is_of_type(other, function));
    const function & o=static_cast<function &>(const_cast<basic &>(other));

    if (serial!=o.serial) {
        return serial < o.serial ? -1 : 1;
    }
    return exprseq::compare_same_type(o);
}

bool function::is_equal_same_type(const basic & other) const
{
    GINAC_ASSERT(is_of_type(other, function));
    const function & o=static_cast<function &>(const_cast<basic &>(other));

    if (serial!=o.serial) return false;
    return exprseq::is_equal_same_type(o);
}

unsigned function::return_type(void) const
{
    if (seq.size()==0) {
        return return_types::commutative;
    }
    return (*seq.begin()).return_type();
}
   
unsigned function::return_type_tinfo(void) const
{
    if (seq.size()==0) {
        return tinfo_key;
    }
    return (*seq.begin()).return_type_tinfo();
}

//////////
// new virtual functions which can be overridden by derived classes
//////////

// none

//////////
// non-virtual functions in this class
//////////

// protected

ex function::pderivative(unsigned diff_param) const // partial differentiation
{
    GINAC_ASSERT(serial<registered_functions().size());
    
    if (registered_functions()[serial].derivative_f==0) {
        throw(std::logic_error(string("function::pderivative(") + registered_functions()[serial].name + "): no diff function defined"));
    }
    switch (registered_functions()[serial].nparams) {
        // the following lines have been generated for max. 10 parameters
    case 1:
        return ((derivative_funcp_1)(registered_functions()[serial].derivative_f))(seq[1-1],diff_param);
        break;
    case 2:
        return ((derivative_funcp_2)(registered_functions()[serial].derivative_f))(seq[1-1], seq[2-1],diff_param);
        break;
    case 3:
        return ((derivative_funcp_3)(registered_functions()[serial].derivative_f))(seq[1-1], seq[2-1], seq[3-1],diff_param);
        break;
    case 4:
        return ((derivative_funcp_4)(registered_functions()[serial].derivative_f))(seq[1-1], seq[2-1], seq[3-1], seq[4-1],diff_param);
        break;
    case 5:
        return ((derivative_funcp_5)(registered_functions()[serial].derivative_f))(seq[1-1], seq[2-1], seq[3-1], seq[4-1], seq[5-1],diff_param);
        break;
    case 6:
        return ((derivative_funcp_6)(registered_functions()[serial].derivative_f))(seq[1-1], seq[2-1], seq[3-1], seq[4-1], seq[5-1], seq[6-1],diff_param);
        break;
    case 7:
        return ((derivative_funcp_7)(registered_functions()[serial].derivative_f))(seq[1-1], seq[2-1], seq[3-1], seq[4-1], seq[5-1], seq[6-1], seq[7-1],diff_param);
        break;
    case 8:
        return ((derivative_funcp_8)(registered_functions()[serial].derivative_f))(seq[1-1], seq[2-1], seq[3-1], seq[4-1], seq[5-1], seq[6-1], seq[7-1], seq[8-1],diff_param);
        break;
    case 9:
        return ((derivative_funcp_9)(registered_functions()[serial].derivative_f))(seq[1-1], seq[2-1], seq[3-1], seq[4-1], seq[5-1], seq[6-1], seq[7-1], seq[8-1], seq[9-1],diff_param);
        break;
    case 10:
        return ((derivative_funcp_10)(registered_functions()[serial].derivative_f))(seq[1-1], seq[2-1], seq[3-1], seq[4-1], seq[5-1], seq[6-1], seq[7-1], seq[8-1], seq[9-1], seq[10-1],diff_param);
        break;

        // end of generated lines
    }        
    throw(std::logic_error("function::pderivative(): no diff function defined"));
}

vector<function_options> & function::registered_functions(void)
{
    static vector<function_options> * rf=new vector<function_options>;
    return *rf;
}

bool function::lookup_remember_table(ex & result) const
{
    return remember_table::remember_tables()[serial].lookup_entry(*this,result);
}

void function::store_remember_table(ex const & result) const
{
    remember_table::remember_tables()[serial].add_entry(*this,result);
}

// public

unsigned function::register_new(function_options const & opt)
{
    unsigned same_name=0;
    for (unsigned i=0; i<registered_functions().size(); ++i) {
        if (registered_functions()[i].name==opt.name) {
            same_name++;
        }
    }
    if (same_name>=opt.functions_with_same_name) {
        // we do not throw an exception here because this code is
        // usually executed before main(), so the exception could not
        // caught anyhow
        cerr << "WARNING: function name " << opt.name
             << " already in use!" << endl;
    }
    registered_functions().push_back(opt);
    if (opt.use_remember) {
        remember_table::remember_tables().
            push_back(remember_table(opt.remember_size,
                                     opt.remember_assoc_size,
                                     opt.remember_strategy));
    } else {
        remember_table::remember_tables().push_back(remember_table());
    }
    return registered_functions().size()-1;
}

//////////
// static member variables
//////////

// none

//////////
// global constants
//////////

const function some_function;
const type_info & typeid_function=typeid(some_function);

#ifndef NO_NAMESPACE_GINAC
} // namespace GiNaC
#endif // ndef NO_NAMESPACE_GINAC

